<script setup lang="ts">
import { ref, nextTick, onMounted, computed } from 'vue'
import type { VForm } from 'vuetify/components'

// store
import { useMaterialStore } from '@/stores/material'
import { useInvoiceStore } from '@/stores/invoice'
import { useInvoiceDetailStore } from '@/stores/invoiceDetail'
import { useUserStore } from '@/stores/user'

//type
import type { Invoice } from '@/types/Invoice/Invoice'
import type { Material } from '@/types/Material'
import type { InvoiceDetail } from '@/types/Invoice/InvoiceDetail'
import auth from '@/services/auth'
import { useAuthStore } from '@/stores/auth'

const invoiceStore = useInvoiceStore()
const materialStore = useMaterialStore()
const userStore = useUserStore()
const invoiceDetailStore = useInvoiceDetailStore()
const form = ref(false)
const refFormAddmat = ref<VForm | null>(null)
const refFormSave = ref<VForm | null>(null)
const loading = ref(false)
const divReceiptItems = ref<HTMLElement | null>(null)
const authStore = useAuthStore()

function onSubmit() { }
onMounted(() => {
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()
})
//save จากปุ่ม add new material
async function save() {
  const { valid } = await refFormSave.value!.validate()
  console.log(valid)
  if (!valid) return
  const existingMaterial = materialStore.addsomeMaterial.find(
    (mat) => mat.name.trim().toLowerCase() === materialStore.editMaterial.name.trim().toLowerCase()
  )

  if (existingMaterial) {
    // หากมีชื่อซ้ำใน addsomeMaterial ให้ทำการอัพเดตค่า
    Object.assign(existingMaterial, materialStore.editMaterial)
  } else {
    // ถ้าไม่ซ้ำให้เพิ่มเข้าไปใน addsomeMaterial
    materialStore.addsomeMaterial.push(materialStore.editMaterial)
  }
  materialStore.editMaterial = Object.assign({}, materialStore.initMaterial)
  materialStore.dialog = false
}
//save จาก materials ที่มีอยู่
async function addMat() {
  if (materialStore.editMaterial.name === '') return
  materialStore.editMaterial.amount = materialStore.amount
  // console.log('wfq' + invoiceDetailStore.getMaterialName(invoiceDetailStore.addinvoiceDetails.length))
  const existingMaterial = invoiceDetailStore.addinvoiceDetails.find(
    (mat) =>
      invoiceDetailStore.getMaterialName(mat.IND_MATERIAL).trim().toLowerCase() ===
      materialStore.editMaterial.name.trim().toLowerCase()
  )

  if (existingMaterial) {
    // หากมีชื่อซ้ำใน addsomeMaterial ให้ทำการอัพเดตค่า
    invoiceDetailStore.updateInvoiceDetail(existingMaterial.IND_MATERIAL, materialStore.amount)
  } else {
    // ถ้าไม่ซ้ำให้เพิ่มเข้าไปใน addsomeMaterial
    invoiceDetailStore.addinvoiceDetail(materialStore.editMaterial)
  }
  materialStore.amount = 0
  materialStore.editMaterial = Object.assign({}, materialStore.initMaterial)
}

//อย่าลืมไปเปิด Invoice service ด้วย

const headersInvoiceItem = [
  {
    title: 'ชื่อ',
    key: 'name',
    value: 'name'
  },
  {
    title: 'จำนวนที่มี',
    key: 'Amount',
    value: 'Amount'
  },
  {
    title: 'ราคา',
    key: 'Price',
    value: 'Price'
  },
  {
    title: 'ลบวัตถุดิบ',
    key: 'actions'
  }
]
async function saveInvoice() {
  for (const material of materialStore.addsomeMaterial) {
    const existingMaterial = materialStore.materials.find(
      (mat) => mat.name.trim().toLowerCase() === material.name.trim().toLowerCase()
    )
    if (existingMaterial) {
      // Update existing material in materials array
      Object.assign(existingMaterial, material)
    } else {
      // Add new material from addsomeMaterial to materials array
      materialStore.materials.push(material)
    }
  }
  console.log('materials: ', materialStore.materials)
  for (const mat of materialStore.materials) {
    console.log('mat: ', mat)
    materialStore.saveMaterial(mat)
  }
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()

  const invoice = ref<Invoice>(invoiceStore.editedInvoice)
  //tran material to invoicedetail
  const newMaterials: Material[] = materialStore.materials
  const newInvoiceDetails: InvoiceDetail[] = invoiceDetailStore.addinvoiceDetails

  const invoiceDetails: InvoiceDetail[] = []

  for (const mat of newInvoiceDetails) {
    const newInvoiceDetail: InvoiceDetail = {
      IND_ID: -1,
      IND_AMOUT: mat.IND_AMOUT,
      IND_MATERIAL: mat.IND_MATERIAL,
      IND_PRICE: mat.IND_PRICE,
      IND_INVOICE: -1
    }

    invoiceDetails.push(newInvoiceDetail)
  }

  try {
    invoice.value = {
      INV_ID: -1,
      INV_PLACE: invoiceStore.place,
      INV_INVOICEDETAILS: invoiceDetails,
      INV_BRANCH: authStore.getCurrentUser()?.branch.id,
      INV_USER: authStore.getCurrentUser()?.id,
      INV_PRICE: invoiceStore.InvoicePrice(invoiceDetails)
    }
  } catch (error) {
    console.error('cant craeet invoice at add invoice some')
  }

  invoiceStore.saveInvoice(invoice.value)
  invoiceDetailStore.updateMatDetail()
  console.log('invoice while saving: ', invoice.value)
  materialStore.getMaterials()
  materialStore.getMaterialsInNewAtt()
  invoiceStore.closeDialog()
}

function deleteItemInSome(item: InvoiceDetail) {
  const existingMaterial = invoiceDetailStore.addinvoiceDetails.find(
    (mat) =>
      invoiceDetailStore.getMaterialName(mat.IND_MATERIAL).trim().toLowerCase() ===
      invoiceDetailStore.getMaterialName(item.IND_MATERIAL).trim().toLowerCase()
  )

  if (existingMaterial) {
    invoiceDetailStore.addinvoiceDetails = invoiceDetailStore.addinvoiceDetails.filter(
      (mat) => mat.IND_ID !== existingMaterial.IND_ID
    )
  }
}
</script>

<template>
  <v-dialog v-model="invoiceStore.addSomeDialog">
    <v-sheet border title="Addsome">
      <div class="d-flex align-center justify-end" style="padding: 5px"></div>
      <v-divider class="border-opacity-50"></v-divider>
      <div style="padding: 0px">
        <div class="align-center">
          <h2 class="text-h4 font-weight-black">Check Invoice</h2>
          <p>การเช็คจำนวนวัตถุดิบที่เหลืออยู่ในคลัง</p>
        </div>
        <v-divider class="border-opacity-50"></v-divider>
      </div>
      <!-- addItem to ItemDetail -->
      <div style="padding-top: 5px; height: 100 px" class="d-flex justify-start">
        <v-row class="d-flex justify-start">
          <v-col cols="12" sm="6" md="4">
            <v-select style="padding-top: 12px" :item-title="(item) => item.name" :item-value="(item) => item"
              :items="materialStore.materials || []" :rules="[(v) => !!v || 'Item is required']"
              v-model="materialStore.editMaterial" label="Item" required variant="outlined" filled rounded
              density="compact"></v-select>
          </v-col>

          <v-col cols="12" sm="6" md="4">
            <v-text-field style="padding-top: 12px" v-model.number="materialStore.amount"
              :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="จำนวน" variant="outlined"
              filled rounded density="compact">
            </v-text-field>
          </v-col>
          <v-col cols="12" sm="6" md="2" style="padding-top: 20px">
            <v-btn icon="mdi-language-markdown" size="small" @click="addMat()">SAVE</v-btn>
          </v-col>
          <v-col>
            <v-btn size="small" @click="materialStore.dialog = true">
              ADD NEW MATERIAL</v-btn>
          </v-col>
          <v-col cols="12" sm="6" md="2">
            <!-- dialog add new material -->
            <v-dialog persistent width="500" v-model="materialStore.dialog">
              <v-card>
                <v-card-title>
                  <span class="text-h5">New Material</span>
                </v-card-title>
                <v-card-text>
                  <v-form ref="refFormSave" v-model="form" @submit.prevent="onSubmit">
                    <v-container>
                      <v-row>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="materialStore.editMaterial.name" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="ชื่อวัตถุดิบ"
                            variant="outlined" filled rounded density="compact"></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model.number="materialStore.editMaterial.minimum" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="จำนวนขั้นต่ำ"
                            variant="outlined" filled rounded density="compact"></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model.number="materialStore.editMaterial.amount" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="จำนวนที่มีอยู่"
                            variant="outlined" filled rounded density="compact"></v-text-field>
                        </v-col>
                        <v-col cols="12" sm="12" md="4">
                          <v-text-field v-model="materialStore.editMaterial.type" :readonly="loading"
                            :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable label="หน่วยเรียก"
                            single-line variant="outlined" filled rounded density="compact"></v-text-field>
                        </v-col>
                      </v-row>
                    </v-container>
                  </v-form>
                  <small>*indicates required field</small>
                </v-card-text>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn variant="outlined" @click="materialStore.closeDialog()">
                    Close
                  </v-btn>
                  <!-- dialog -->
                  <v-btn variant="outlined" @click="save()"> Save </v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-col>
        </v-row>
      </div>

      <!-- table show material -->
      <v-divider class="border-opacity-50"></v-divider>
      <v-data-table :headers="headersInvoiceItem" :items="invoiceDetailStore.addinvoiceDetails" height="300"
        fixed-header hide-default-footer disable-pagination class="flex-table" overflow-y="hidden">
        <template v-slot:item="{ item }">
          <tr>
            <td>{{ invoiceDetailStore.getMaterialName(item.IND_MATERIAL) }}</td>
            <td>
              <v-text-field class="d-flex align-center" style="padding: 0px" variant="outlined" rounded="2"
                :rules="[(v) => !!v || 'Field is required']" background-color="primary" v-model.number="item.IND_AMOUT"
                clearable></v-text-field>
            </td>
            <td>
              <v-text-field class="d-flex align-center" style="padding: 0px" variant="outlined" rounded="2"
                :rules="[(v) => !!v || 'Field is required']" background-color="primary" v-model.number="item.IND_PRICE"
                clearable></v-text-field>
            </td>
            <td>
              <v-icon icon="mdi-delete-circle" size="large" color="red" @click="deleteItemInSome(item)"></v-icon>
              <!-- @click="invoiceStore.deleteItemSome(item)" -->
            </td>
          </tr>
        </template>
      </v-data-table>

      <v-card-actions>
        <v-spacer></v-spacer>
        <v-spacer></v-spacer>
        <v-spacer></v-spacer>
        <v-row>
          <v-col cols="12" md="6">
            <v-text-field style="" v-model="invoiceStore.place" :rules="[(v) => !!v || 'Field is required']"
              class="mb-2" clearable label="สถานที่ซื้อ" variant="outlined" filled rounded
              density="compact"></v-text-field>
          </v-col>

          <v-col cols="12" md="6">
            <v-btn @click="invoiceStore.closeDialog()">Close</v-btn>
            <!-- save ใหญ่ -->
            <v-btn @click="saveInvoice()">Save</v-btn>
          </v-col>
        </v-row>
      </v-card-actions>
    </v-sheet>
  </v-dialog>
</template>

<style scoped>
.v-sheet {
  background-color: #fff5e8;
}

.v-sheet,
.v-card {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
}

.v-toolbar {
  border-top-left-radius: 15px;
  border-top-right-radius: 15px;
  text-decoration: none;
  background-color: #ab9283;
}

.v-toolbar-title {
  font-weight: bold;
  font-size: 24px;
  color: white;
}

.v-table {
  border-bottom-left-radius: 15px;
  border-bottom-right-radius: 15px;
  text-decoration: none;
  background-color: #fff5e8;
}

.v-btn {
  background-color: #ffcb5e;
  border-radius: 30px;
  padding: 8px 16px;
}

.info {
  font-size: 14px;
}
</style>
